program confram;
(* Configures Eternal Ramdisk *)
  function IO_Result : integer; EXTERNAL;
  procedure IO_Check(b : boolean); EXTERNAL;
(* --------------------------------------------------------------- *)
function lower(c : char) : char;
BEGIN
    if c in ['A'..'Z'] then lower := chr( ord(c) + ord('a') - ord('A') )
    ELSE lower := c;
end;
(* --------------------------------------------------------------- *)
procedure getsize(f : string; var ident : char; var size : integer);
VAR
    t : text;
    c : char;
BEGIN
    ident := 'h';
    size := 100;

    IO_Check(FALSE);
    reset(t, f);
    if IO_Result >=  0 then begin
	IO_Check(TRUE);
	read(t, c);
	ident := chr(ord(c) + ord('a'));

	read(t, c);
	size := ord(c) * $100;
	read(t, c);
	size := size + ord(c);
    end;
    IO_Check(TRUE);
    close(t);
end;
(* --------------------------------------------------------------- *)
function atoi(stringg : string) : integer;
VAR
    o : integer;
    i : integer;
BEGIN
    o := 0;
    for i := 1 to length(stringg) do begin
	if stringg[i] in ['0'..'9'] then
	    o := o * 10 + ord(stringg[i]) - ord('0')
	ELSE o := -1;
    end;
    atoi := o;
end;
(* --------------------------------------------------------------- *)
procedure driver;
CONST
    data = 'RAMDISK.DAT';
VAR
    ident : char;
    newident : char;
    size : integer;
    newsize : integer;
    stringg : string;
    t : text;
BEGIN
    getsize(data, ident, size);
    REPEAT
	write('Drive Identifier? (',ident,') ' ); readln(stringg);    
	if stringg = '' then
            newident := ident
        else
            newident := lower(stringg[1]);
    UNTIL newident in ['c'..'p'];
    REPEAT
	write( 'Size? (',size, ') '  ); readln(stringg);
	if stringg = '' then
            newsize := size
        else
            newsize := atoi(stringg);
    UNTIL newsize >= 0;

    rewrite(t, data);
    write(t, chr(ord(newident)-ord('a')) );
    write(t, chr(shr(newsize, 8)));
    write(t, chr(newsize & $FF));
    close(t);
end;
(* --------------------------------------------------------------- *)
BEGIN
writeln('Eternal Ramdisk configuration program by Robert Fischer');
writeln('                                         80 Killdeer Road');
writeln('                                         Hamden, CT   06517');
writeln;
writeln('This program is Public Domain, and is meant to go with ETERNAL.PRG');
writeln('and ETERNAL.S');
writeln;
writeln('Portions of this code are Copyright (c) 1986, OSS, CCD.');
writeln('Used by permission of OSS.');
    driver;
end.
